#!/usr/bin/perl

# KNOWN BUGS:
# - This is only the cweb backend :)

# - Section level should be customizable
# - Language attribute is not checked (should be "C" or "C++")
# - #include line imm. followed by <SnippetUse> gets no \n separator
# - #line directives issued by cweb reference the .w, not the .sweb

use SGMLS;                      # Use the SGMLS package.
use SGMLS::Output;              # Use stack-based output.

use SGMLS::SWEB;
#use SGMLS::entities::general;

sgml ('<WEB>', "% generated by sweb2fweb.pl\n");
sgml ('</WEB>', "\n@* \INDEX.\n");

sgml ('<LITSECT>', sub {
    my ($element,$event) = @_;

    LitSect->new($element);

    output "\n@* ";
});

sgml ('<SNIPPET>', sub {
    my ($element,$event) = @_;

    Snippet->new($element);

    $sect = $element->in('LITSECT');

    $sect->inc_nBlurbs;
    if ($sect->get_nBlurbs > 1) {
	output ("\n@ ");
    } else {
	output "\n";
    }
});

sgml ('<FILE>', sub {
    my ($element,$event) = @_;
    my $name = $element->attribute('NAME')->value;

    my $snippet = $element->in('SNIPPET');
    $snippet->set_file($name);

    if ($element->attribute('ISDEFAULT')->value eq 'DEFAULT') {
	output ("\n", '@a', "\n");
    } else {
	output ('@(', $name, '@>=', "\n");
    }
});

sgml ('<TITLE>', sub {
    my ($element,$event) = @_;
    my $parent = $element->parent;

    if ($parent->name eq 'SNIPPET') {
	output ("@<");
    }
});

sgml ('</TITLE>', sub {
    my ($element,$event) = @_;
    my $parent = $element->parent;

    if ($parent->name eq 'LITSECT') {
	output (".\n");
    } elsif ($parent->name eq 'SNIPPET') {
	output ("@>=\n");
    }
});

#  sub snippetuseInToplevelCode ($) {
#      my ($element) = @_;

#      my $snippet = $element->within('SNIPPET');
#      die "<SnippetUse> outside of <Snippet>" unless $snippet;

#      return defined($snippet->get_file);
#  }

sgml ('<SNIPPETUSE>', "@<");
sgml ('</SNIPPETUSE>', sub {
    my ($element,$event) = @_;

#    if (snippetuseInToplevelCode($element)) {
	output ("@>@;");
#      } else {
#  	output ("@>;");
#      }
});

sgml ('<BLURB>', "\n");
sgml ('</BLURB>', "\n");

# common entities
sgml('|[lt    ]|', '<');
sgml('|[gt    ]|', '>');
sgml('|[amp   ]|', '&');

sgml('|[ndash ]|', '--');
sgml('|[mdash ]|', '---');
